use std::{collections::HashMap, error::Error};

use regex::Regex;

/*

[lib]
crate-type = ["staticlib", "cdylib", "lib"]
*/

// https://soundcloud.com/soundcloud regex: "<script crossorigin src=\"" search for client_id inside of script

// https://soundcloud.com/versions.json

// likes: https://api-v2.soundcloud.com/users/774639751/likes?client_id=zFEmsF1cEZZQ92nRRXKOg7e6ibFR1L7c&limit=10&offset=0&linked_partitioning=1&app_version=1734537250&app_locale=en

// playlists: https://api-v2.soundcloud.com/users/774639751/playlists_without_albums?client_id=zFEmsF1cEZZQ92nRRXKOg7e6ibFR1L7c&limit=10&offset=0&linked_partitioning=1&app_version=1734537250&app_locale=en

#[tokio::main]
async fn main() -> Result<(), Box<dyn std::error::Error>> {
    println!("{}", get_app().await.unwrap().unwrap());
    
    Ok(())
}

async fn get_likes() -> Result<Option<String>, Box<dyn Error>> {

}

async fn get_playlists() -> Result<Option<String>, Box<dyn Error>> {
    
}

async fn get_app() -> Result<Option<String>, Box<dyn Error>> {
    let resp = reqwest::get("https://soundcloud.com/versions.json")
        .await?
        .text()
        .await?;

    let json: serde_json::Value = serde_json::from_str(&resp).expect("JSON was not well-formatted");
    
    Ok(
        Some(
            json.get("app")
                .unwrap()
                .as_str()
                .unwrap()
                .to_string()
            )
        )
}

async fn get_client_id() -> Result<Option<String>, Box<dyn Error>> {
    let resp = reqwest::get("https://soundcloud.com/soundcloud")
        .await?
        .text()
        .await?;

    let rg = Regex::new(r#"src=".+""#).unwrap();

    let mut urls = Vec::new();

    for cap in Regex::new(r#"<script .+src="https://.+""#).unwrap().find_iter(&resp) {
        let script_block = cap.as_str();
        if let Some(m) = rg.find(script_block) {
            urls.push(&m.as_str()[5..m.as_str().len()-1]);
        }
    }

    let rg = Regex::new(r#""client_id=[a-zA-Z0-9]+""#).unwrap();

    for i in 0..urls.len() {
        let url = urls.get(i).unwrap().to_string();
        let resp = reqwest::get(&url)
            .await?
            .text()
            .await?;

        if let Some(m) = rg.find(&resp) {
            return Ok(Some(m.as_str()[11..m.as_str().len()-1].to_string()));
        }
    }
    Ok(None)
}